<template>
  <div class="serie-item-buttons">
    <div v-if="isWebtoonAndLocked">
      <img class="album-locked" :src="require('~/assets/images/ic-lock.svg')" />
    </div>
    <div v-if="displayKnowMore">
      <a :href="albumUrl">
        <img
          class="album-know-more only-mobile"
          :src="require('~/assets/images/ic-info-black.svg')"
        />
        <AppButton class="only-desktop" :theme="'white'">
          {{ $t('serie.know_more') }}
        </AppButton>
      </a>
    </div>
    <div v-else>
      <div class="product_lower_price">
        <div v-if="canBeAddInLib" class="price-ctn">
          <div
            v-if="!serie.isWebtoon && albumIsFree"
            class="album-free only-desktop"
          >
            {{ $t('serie.free') }}
          </div>
          <div v-if="!inLib">
            <AppButton
              class="only-desktop custom-button"
              :theme="'white'"
              @click.native="addToLibrary()"
              >{{ $t('catalog.add_library') }}</AppButton
            >
            <AppButton
              class="only-mobile small-button"
              :theme="'white'"
              @click.native="addToLibrary()"
            >
              <img
                class="album-know-more"
                :src="require('~/assets/images/ic-library-add-black.svg')"
              />
            </AppButton>
          </div>
          <div v-else>
            <AppButton
              class="only-desktop custom-button"
              :theme="'dark'"
              @click.native="removeFromLibrary()"
              >{{ $t('catalog.remove_library') }}</AppButton
            >
            <AppButton
              class="only-mobile small-button mobile-lib-btn"
              :theme="'dark'"
              @click.native="removeFromLibrary()"
            >
              <img
                class="album-know-more"
                :src="require('~/assets/images/ic-library-added.svg')"
              />
            </AppButton>
          </div>
        </div>
        <div v-else-if="canBuy" class="price-ctn">
          <div class="album-price">
            <span v-if="hasOldPrice">
              <del>
                <PriceFormat
                  class="only-desktop"
                  :price="album.oldPrice"
                  :currency="$utils.getCurrencySymbol(album.currency)"
                />
                <PriceFormatPlain
                  class="only-mobile-custom-price"
                  :price="album.oldPrice"
                  :currency="$utils.getCurrencySymbol(album.currency)"
                />
              </del>
            </span>
            <template v-if="hasPrice">
              <PriceFormat
                class="only-desktop"
                :price="album.price"
                :currency="$utils.getCurrencySymbol(album.currency)"
              />
              <PriceFormatPlain
                class="only-mobile-custom-price"
                :price="album.price"
                :currency="$utils.getCurrencySymbol(album.currency)"
              />
            </template>
          </div>

          <div v-if="!inCart">
            <AppButton class="only-desktop custom-button" @click="addToCart()">
              {{ $t('catalog.add_basket') }}
            </AppButton>
            <AppButton class="only-mobile small-button" @click="addToCart()">
              <span class="icon icon-cart"></span>
            </AppButton>
          </div>
          <div v-else-if="inCart">
            <AppButton
              class="only-desktop custom-button"
              theme="white"
              @click="removeFromCart()"
            >
              {{ $t('catalog.added_basket') }}
            </AppButton>
            <AppButton
              class="only-mobile small-button mobile-cart-btn"
              theme="white"
              @click="removeFromCart()"
            >
              <img :src="require('~/assets/images/ic_cart_clicked.png')" />
            </AppButton>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import AppButton from '~/components/ui/AppButton'
import PriceFormat from '~/components/ui/PriceFormat'
import PriceFormatPlain from '~/components/ui/PriceFormatPlain'

export default {
  components: {
    AppButton,
    PriceFormat,
    PriceFormatPlain
  },
  props: {
    serie: {
      type: Object,
      required: true
    },
    album: {
      type: Object,
      required: true
    },
    albumUrl: {
      type: String,
      required: true
    },
    isSubscription: {
      type: Boolean,
      required: false,
      default: false
    },
    connected: {
      type: Boolean,
      required: false,
      default: false
    },
    subscribed: {
      type: Boolean,
      required: false,
      default: false
    }
  },
  computed: {
    inCart() {
      return this.album.inCart
    },
    inLib() {
      return this.album.inUserLibrary
    },
    hasPrice() {
      return this.album.price && this.album.price !== 'N/A'
    },
    hasOldPrice() {
      return (
        this.album.oldPrice &&
        this.album.oldPrice !== 'N/A' &&
        this.album.oldPrice > 0.0
      )
    },
    canBuy() {
      return (
        this.connected &&
        !this.albumIsFree &&
        !this.album.inUserSubscription &&
        !this.album.inUserLibrary &&
        this.hasPrice
      )
    },
    displayKnowMore() {
      return (
        (!this.serie.isWebtoon && !this.connected) ||
        (this.connected && this.album.onlyRead)
      )
    },
    isWebtoonAndLocked() {
      if (
        !this.connected &&
        this.serie.isWebtoon &&
        !this.albumIsFree &&
        !this.album.inUserSubscription
      ) {
        return true
      }

      return false
    },
    albumIsFree() {
      return !this.album.price || this.album.price === '0.00'
    },
    canBeAddInLib() {
      return (
        this.connected &&
        (this.albumIsFree || this.album.inUserSubscription) &&
        !this.album.onlyRead
      )
    }
  },
  methods: {
    async refreshFromServer() {
      this.$store.dispatch('updateCartItemCount')

      // reload the series data to update banners
      this.$root.$emit('refreshSerie')
    },
    async addToCart() {
      const data = await this.$api.addAlbumToCart(this.album.id)
      if (data) {
        this.album.inCart = true
        this.refreshFromServer()

        this.$utils.gtmEvent({
          event: 'addToCart',
          EventCategory: 'ecommerce',
          EventAction: 'add to cart',
          ecommerce: {
            currencyCode: this.album.currency,
            add: {
              products: [
                {
                  name: this.album.title,
                  id: this.album.id,
                  price: this.album.price,
                  brand: this.serie.shelf.name,
                  category: 'Album',
                  variant: this.serie.publishers.length
                    ? this.serie.publishers.map((v) => v.name).join(', ')
                    : '',
                  dimension1: this.serie.target.name,
                  dimension2: this.album.chapter ?? this.album.volume ?? 0,
                  quantity: 1
                }
              ]
            }
          }
        })
      }
    },
    async removeFromCart() {
      const data = await this.$api.removeAlbumFromCart(this.album.id)
      if (data) {
        this.album.inCart = false
        this.refreshFromServer()

        this.$utils.gtmEvent({
          event: 'removeFromCart',
          EventCategory: 'ecommerce',
          EventAction: 'remove from cart',
          ecommerce: {
            currencyCode: this.album.currency,
            remove: {
              products: [
                {
                  name: this.album.title,
                  id: this.album.id,
                  price: this.album.price,
                  brand: this.serie.shelf.name,
                  category: 'Album',
                  variant: this.serie.publishers.length
                    ? this.serie.publishers.map((v) => v.name).join(', ')
                    : '',
                  dimension1: this.serie.target.name,
                  dimension2: this.album.chapter ?? this.album.volume ?? 0,
                  quantity: 1
                }
              ]
            }
          }
        })
      }
    },
    async addToLibrary() {
      const data = await this.$api.addAlbumToLibrary(this.album.id)
      if (data) {
        this.album.inUserLibrary = true
      }

      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'Clic_Bouton',
        EventAction: 'Bibliotheque',
        EventLabel: `Ajouter_${this.serie.name}`
      })
    },
    async removeFromLibrary() {
      const data = await this.$api.removeAlbumFromLibrary(this.album.id)
      if (data) {
        this.album.inUserLibrary = false
      }
      this.$utils.gtmEvent({
        event: 'gtm.event',
        EventCategory: 'Clic_Bouton',
        EventAction: 'Bibliotheque',
        EventLabel: `Retirer_${this.serie.name}`
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.serie-item-buttons {
  .album-locked {
    position: absolute;
    bottom: calc(50% - 15px);
    right: 6rem;

    @media (max-width: 768px) {
      right: 1rem;
      bottom: 1rem;

      width: 16px;
      height: 20px;
    }
  }

  .album-know-more {
    cursor: pointer;

    &.only-mobile {
      padding-bottom: 0.5rem;
      padding-right: 0.5rem;
    }
  }

  .price-ctn {
    display: flex;
    flex-direction: column;

    .album-price {
      del {
        color: grey;
      }
    }

    @media (max-width: 768px) {
      flex-direction: row;
      white-space: nowrap;
      align-items: flex-end;
      align-items: center;

      .album-price {
        padding-right: 1rem;
        padding-bottom: 0.5rem;
        font-size: 20px;
      }
    }
  }

  .album-free {
    font-size: 12px;
    color: #ff641e;
    text-align: center;
    padding: 2rem;
  }

  .album-price {
    text-align: center;
    padding: 1rem 0;
    font-family: DINCond-Bold;
    font-size: 40px;
    font-size: 2.5rem;
    text-align: center;
  }

  .only-mobile,
  .only-mobile-custom-price {
    display: none;
  }

  .only-desktop {
    display: block;
  }

  @media (max-width: 768px) {
    .only-mobile-custom-price {
      display: inline;
    }

    .only-mobile {
      display: block;
    }

    .only-desktop {
      display: none;
    }
  }
}
</style>
